module Tests

import Options
import TAP
import Tests.CharExtra
import Tests.Lexer
import Tests.Parser
import Tests.Equal
import System


allTests = [
  CharExtra.tests,
  Lexer.tests,
  Parser.tests,
  Equal.tests
]

main = do
  opts <- getTestOpts
  go <- case opts.tapVersion of
    "13" => pure TAP.mainFlat
    "14" => pure TAP.main
    _    => do putStrLn "unrecognised TAP version; use 13 or 14"; exitFailure
  go allTests
